#!/bin/csh
##############################################################################
#	Program: Quality filter
#	Input: Input is Fastq file
#	Input parameters: first argument = Reads 1 and second argumnet is Reads 2
#	
#	Written: Chandra Sekhar Pedamallu
#	Copyright@DFCI, The Broad Institute
#############################################################################

echo "Quality filter processing"

set reads1=$1
echo "Read 1: "$reads1
echo $reads1 > .tmp
set namefile1 = `awk '{ns=split($1, x, "/"); print x[ns];}' .tmp`
set ncharr = `echo $1 | awk '{print length($0)}'`
@ nchar=$ncharr
@ no_args=1
set ncharr = `echo $2 | awk '{print length($0)}'`
@ nchar1=$ncharr

# Quality cutoff score
set Qcutoff="15" 

# Number of bases not meet the required cutoff
set nobase="3"

# Offset Q-value (Please  check with your sequencing center"
set offset="33"

echo "Running the Quality filtering with default paramters"
if($nchar1 > 0) then
	set reads2=$2 # Splits to reads
	echo $reads2 > .tmp
	set namefile2 = `awk '{ns=split($1, x, "/"); print x[ns];}' .tmp`
	@ no_args++
endif


echo $no_args
if( $no_args == 2 ) then
	cat $reads1 $reads2 > $reads1"_"$namefile2
	echo "Conversion from Fastq to FQ one"
	javac Fastq2FQone.java

	java Fastq2FQone $reads1"_"$namefile2 $reads1"_"$namefile2".fq1"

	echo "Here is the Quality reads "$reads1"_"$namefile2"_Qualityreads.fq1"
	javac QualFilter.java

	java QualFilter $reads1"_"$namefile2".fq1" $reads1"_"$namefile2"_Qualityreads.fq1" $Qcutoff $nobase $offset

else if( $no_args == 1) then
	
	echo "Conversion from Fastq to FQ one"
	javac Fastq2FQone.java
	java Fastq2FQone $reads1 $reads1".fq1"
	
	echo "Here is the Quality reads "$reads1"_Qualityreads.fq1"
	javac QualFilter.java

	java QualFilter $reads1".fq1" $reads1"_Qualityreads.fq1" $Qcutoff $nobase $offset

endif



