/*
	Author: Chandra Sekhar Pedamallu
	Description: This program is meant remove reads that are more than 20 at a given position

	Input:<reads file> <threshold> 
	
	Output: 
	 outfile("Output");

	Commandline: ./remove_positions <referencegene> <gene_expression>

	Updates:
	none
	
*/

#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<string.h>
#include<stdio.h>
#include<fstream>
#include<iostream>
#include<vector>
#include<time.h>

using namespace std;
const int no_put=10;
char* trim(char *str){
	 char* cp;
	while(*str && strchr(" \n\r\t", *str)!=NULL)
		str++;
	cp=str+strlen(str)-1;
	while(cp>str && strchr(" \n\r\t", *cp)!=NULL)
		*cp-- = '\0';
	return str;
}

int main(int argc, char* argv[]){
	time_t start, end;
	time(&start); // Start time
	//printf("%s\n", "Start");
if(argc < 2){
	cout<<"please include reference name and snp name"<<endl;
	cout<<"./gname_snp <reference file> <snpfile>"<<endl;
	exit(0);	
}
// read reads

	ifstream fin(argv[1]);
	vector<string> chr;
	vector<int> chrstart;
	vector<string> read;
	string line;
	int no_line=0;
	if(fin.is_open()){
		while(!fin.eof()){
			getline(fin, line);
			if(line.size()>0){
				//cout<<line<<endl;
				char *str;
				str=new char[line.size()+1];
				strcpy(str, line.c_str());
				char *strtemp = trim(str);
				if(strlen(strtemp)>0){
					char *p;
					int count=0;
					p=strtok(str, "\t");
					string in, out, out1;
					int star, ende;	
					while(p!=NULL){
						if(count==1){in=p;}
						p=strtok(NULL,"\t");
						count++;
					}
					chr.push_back(in);
					read.push_back(line);
					
					no_line++;
				}
			}
		}
	}
	cout<<no_line<<" "<<read.size()<<endl;
	fin.close();
// End of reference gene
	int thres=atoi(argv[2]);
	
	vector<string> chr_new;
	vector<string> read_new;
	
	int no_counts=0;
	string perchr="";
	
	//string names=argv[2];	
	//string sstmp = names + ".updated";
	char *str = argv[3];
	//str=new char[sstmp.size()+1];
	//strcpy(str, sstmp.c_str());
	ofstream outfile(str);


	for(int i=0; i<read.size(); i++){
		no_counts=0;
		if(chr_new.size()==0){
			perchr=chr.at(i);
			chr_new.push_back(chr.at(i));
			read_new.push_back(read.at(i));
		}
		else{
			if((chr.at(i).compare(perchr)==0)){
			}
			else{
				for(int k=0; k<read_new.size(); k++){
					outfile<<read_new.at(k)<<endl;
				}
				chr_new.clear();
				read_new.clear();
			}

			if(chr_new.size()==0){
				perchr=chr.at(i);
				chr_new.push_back(chr.at(i));
				read_new.push_back(read.at(i));
			}
			else{
				vector<string> chr_new1=chr_new;
				int no_rem=0;
				for(int j=0; j<chr_new1.size(); j++){
					if((chr.at(i).compare(chr_new.at(j))==0)){
						no_counts++;
					}
					else{
						if(j==chr_new1.size()-1){
							chr_new.push_back(chr.at(i));
							read_new.push_back(read.at(i));
							no_rem++;
						}
					}
					if(no_counts >= thres){
						break;
					}
					else{
						if(no_rem ==0){
							if(j==chr_new1.size()-1){
								chr_new.push_back(chr.at(i));
								read_new.push_back(read.at(i));
							}
						}
	
					}
				}
			}
		}
	}
	cout<<read_new.size()<<endl;

	for(int i=0; i<read_new.size(); i++){
		outfile<<read_new.at(i)<<endl;
	}
	outfile.close();

	time(&end);
	double dif=difftime(end, start); // End time
	cout<<"Time"<<dif<<endl;

	return 0;
}
