#!/usr/bin/env python
# Created: Chandra Sekhar Pedamallu, DFCI
# Purpose: mapper repeatmasker jobs
# Updates: Added multiple database parts
# DFCI @ copyright

import sys
import os
import commands
import random

#input comes from STDIN
for line in sys.stdin:
	hadooploc="/usr/local/hadoop-1.0.3"
        # Strip off spaces infornt and behing the lines
        line = line.strip()
        print line
        tokens=line.split("/")
        name=""
        for token in tokens:
                name=token
        print name

        # config file download
        nconfignum=random.randint(0, 1000000)
        nconfig=str(nconfignum)

        # Download config file from hadoop file system
        wget1=hadooploc + "/bin/hadoop fs -get /user/root/config/config /usr/local/" 
        wget1= wget1 + nconfig
        wget=commands.getstatusoutput(wget1)
        print wget

        #read config file from hadoop file system
        stat=""
        namefile="/usr/local/" + nconfig
        ff = open(namefile, 'r')
        data = ff.readlines()
        psubo=data[9].strip()
        stat=data[1].strip()
        ff.close()
   
        # Wget the reads file
        wget1="/usr/bin/s3cmd -f -c /root/.s3cfg get " + line
        wget1=wget1 + " /mnt/mfiles/reads/"
        wget=commands.getstatusoutput(wget1)
        print wget
        print "\n"

        #File names
        fFQ=name
        fFASTA=name + ".fasta"
        fOUT=name + ".xml"
        
	fMEGAUn=name + ".vbacterial.unmapped.fq1"
        fBMEGA=name + ".vbacterial.HitTable"
        fBMEGAU=name + ".updated.vbacterial.HitTable"
	
	fBLASTNUn=name + ".vall.blastN.unmapped.fq1"
	fFBLASTN=name + ".vall.blastN.HitTable"
	fFBLASTNU=name + ".updated.vall.blastN.HitTable"
	
	fBLASTXUn=name + ".vfungal.viral.blastX.unmapped.fq1"
	fFBLASTX=name + ".vfungal.viral.blastX.HitTable"
	fFBLASTXU=name + ".updated.vfungal.viral.blastX.HitTable"


	# filenames of statistics
	sREP=name + ".vstat.bpos1"
	sNF=name + ".vstat.blastnfung"
	sNV=name + ".vstat.blastnviral"
	sXF=name + ".vstat.blastxfung"
	sXV=name + ".vstat.blastxviral"
	sMB=name + ".vstat.megaBacterial"

	#Conversion FQ1 into fasta file
        REPF1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
        REPF1=REPF1 + "FQone2Fasta.java"
        REPF=commands.getstatusoutput(REPF1)
        print REPF

        FQ12FASTA="/usr/local/jdk1.6.0_21/bin/java -classpath . FQone2Fasta /mnt/mfiles/reads/" + fFQ
        FQ12FASTA=FQ12FASTA + " /mnt/mfiles/reads/"
        FQ12FASTA=FQ12FASTA + fFASTA
        p6=commands.getstatusoutput(FQ12FASTA);
        print p6
	
	#STATISTICS
	print "Statistics after Megablast"
	STAT1="/bin/grep \">\" /mnt/mfiles/reads/" + fFASTA
        STAT1=STAT1 + " | wc -l"
        STAT1=STAT1 + " > /mnt/mfiles/reads/"
        STAT1=STAT1 + sREP
        STAT=commands.getstatusoutput(STAT1);
        print STAT

        out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + sREP
        out1=out1 + " s3://"
	out1=out1 + stat
	out1=out1 + "/"
        print out1
        out=commands.getstatusoutput(out1)

	#Megablast on reads over Bacterial Genome#############RAM Tools####################### 
	mega1="/root/blast-2.2.23/bin/megablast -i /mnt/mfiles/reads/" + fFASTA	
	mega1=mega1 + " -d \"/mnt/mfiles/ref/bacterial.db\" -m 7 -a 4 -D 2 -e 0.0000001 -W 16 -b 0 -v 5 -f -F F -o /mnt/mfiles/reads/"
	mega1=mega1 + fOUT
        print mega1
	p6=commands.getstatusoutput(mega1);
        print p6

	#Blastxml.java
	blastxml1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
	blastxml1=blastxml1 + "blastxml.java"
	blastxml=commands.getstatusoutput(blastxml1)
	print blastxml

	# Convert BLASTXML
	blastxml1="/usr/local/jdk1.6.0_21/bin/java -classpath . blastxml /mnt/mfiles/reads/" + fOUT
	blastxml1=blastxml1 + " /mnt/mfiles/reads/"
	blastxml1=blastxml1 + fBMEGA
	blastxml=commands.getstatusoutput(blastxml1);
       	
	# g++ blastxml.cc
        #CC1="/usr/bin/g++ blastxml.cc -o blastxml"
	#print CC1
	#p6=commands.getstatusoutput(CC1);
       	#print p6

       	# Run Blastxml.cc
        #CC1="./blastxml /mnt/mfiles/reads/" + fOUT
	#CC1=CC1 + " /mnt/mfiles/reads/"
	#CC1=CC1 + fBMEGA
        #p6=commands.getstatusoutput(CC1);
       	#print p6
	
	# create full query from the original reads and update Hit table
        REPF1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
        REPF1=REPF1 + "extractFullQuert4BHitTable.java"
        REPF=commands.getstatusoutput(REPF1)
        
        FQ12FASTA="/usr/local/jdk1.6.0_21/bin/java -classpath . extractFullQuert4BHitTable /mnt/mfiles/reads/" + fFQ
        FQ12FASTA=FQ12FASTA + " /mnt/mfiles/reads/"
        FQ12FASTA=FQ12FASTA + fBMEGA
        FQ12FASTA=FQ12FASTA + " /mnt/mfiles/reads/"
        FQ12FASTA=FQ12FASTA + fBMEGAU
        p6=commands.getstatusoutput(FQ12FASTA);
        print p6
        
	#Upload the Hittable
	out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + fBMEGAU 
        out1=out1 + " s3://"
	out1=out1 + psubo
	out1=out1 + "/"
        out=commands.getstatusoutput(out1)
	print out1
	
	# Extract unmapped reads from the Hit table
        REPF1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
        REPF1=REPF1 + "extractUnmapped_latest.java"
        REPF=commands.getstatusoutput(REPF1)
        FQ12FASTA="/usr/local/jdk1.6.0_21/bin/java -classpath . extractUnmapped_latest /mnt/mfiles/reads/" + fBMEGA
        FQ12FASTA=FQ12FASTA + " 1E-10 /mnt/mfiles/reads/"
        FQ12FASTA=FQ12FASTA + fFQ
        FQ12FASTA=FQ12FASTA + " /mnt/mfiles/reads/"
        FQ12FASTA=FQ12FASTA + fMEGAUn
        p6=commands.getstatusoutput(FQ12FASTA);
        print p6

	#Upload the unmapped
	out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + fMEGAUn
        out1=out1 + " s3://"
	out1=out1 + psubo
	out1=out1 + "/"
        out=commands.getstatusoutput(out1)
        print out1
	#Megablast on reads over Bacterial Genome#############RAM Tools####################### 

	#BlastN on reads over Virus, Fungal, Human, Bacterial Genome#################################### 
	mega1="/root/blast-2.2.23/bin/blastall -p blastn -i /mnt/mfiles/reads/" + fFASTA	
	mega1=mega1 + " -d \"/mnt/mfiles/ref/fungi.db /mnt/mfiles/ref/viral.db /mnt/mfiles/ref/bacterial.db /mnt/mfiles/ref/ref.db"
	mega1=mega1 + "\" -m 7 -e 0.01 -W 7 -r 1 -q -3 -G 5 -E 2 -F F -a 4 -b 0 -v 5 -o /mnt/mfiles/reads/"
	mega1=mega1 + fOUT
	print mega1
       	p6=commands.getstatusoutput(mega1);
       	print p6

	#Blastxml.java
	blastxml1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
	blastxml1=blastxml1 + "blastxml.java"
	blastxml=commands.getstatusoutput(blastxml1)
	print blastxml

	# Convert BLASTXML
	blastxml1="/usr/local/jdk1.6.0_21/bin/java -classpath . blastxml /mnt/mfiles/reads/" + fOUT
	blastxml1=blastxml1 + " /mnt/mfiles/reads/"
	blastxml1=blastxml1 + fFBLASTN
	blastxml=commands.getstatusoutput(blastxml1);

       	# g++ blastxml.cc
        #CC1="/usr/bin/g++ blastxml.cc -o blastxml"
	#print CC1
	#p6=commands.getstatusoutput(CC1);
       	#print p6

       	# Run Blastxml.cc
        #CC1="./blastxml /mnt/mfiles/reads/" + fOUT
	#CC1=CC1 + " /mnt/mfiles/reads/"
	#CC1=CC1 + fFBLASTN
        #p6=commands.getstatusoutput(CC1);
       	#print p6
	
	# create full query from the original reads and update Hit table
        REPF1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
        REPF1=REPF1 + "extractFullQuert4BHitTable.java"
        REPF=commands.getstatusoutput(REPF1)
        FQ12FASTA="/usr/local/jdk1.6.0_21/bin/java -classpath . extractFullQuert4BHitTable /mnt/mfiles/reads/" + fFQ
        FQ12FASTA=FQ12FASTA + " /mnt/mfiles/reads/"
        FQ12FASTA=FQ12FASTA + fFBLASTN
        FQ12FASTA=FQ12FASTA + " /mnt/mfiles/reads/"
        FQ12FASTA=FQ12FASTA + fFBLASTNU
        p6=commands.getstatusoutput(FQ12FASTA);
        
	#Upload the Hittable
	out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + fFBLASTNU
        out1=out1 + " s3://"
	out1=out1 + psubo
	out1=out1 + "/"
	out=commands.getstatusoutput(out1)
        print out1
	
	# Extract unmapped reads from the Hit table
        REPF1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
        REPF1=REPF1 + "extractUnmapped_latest.java"
        REPF=commands.getstatusoutput(REPF1)
        FQ12FASTA="/usr/local/jdk1.6.0_21/bin/java -classpath . extractUnmapped_latest /mnt/mfiles/reads/" + fFBLASTN
        FQ12FASTA=FQ12FASTA + " 1E-10 /mnt/mfiles/reads/"
        FQ12FASTA=FQ12FASTA + fFQ
        FQ12FASTA=FQ12FASTA + " /mnt/mfiles/reads/"
        FQ12FASTA=FQ12FASTA + fBLASTNUn
        p6=commands.getstatusoutput(FQ12FASTA);
        print p6

	#Upload the unmapped
	out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + fBLASTNUn
        out1=out1 + " s3://"
	out1=out1 + psubo
	out1=out1 + "/"
        out=commands.getstatusoutput(out1)
        print out1
	#BlastN on reads over Bacterial, Human, Viral, Fungal Genome#################################### 

	#BlastX on reads over Viral, Fungal Genome#################################### 
	mega1="/root/blast-2.2.23/bin/blastall -p blastx -i /mnt/mfiles/reads/" + fFASTA	
	mega1=mega1 + " -d \"/mnt/mfiles/ref/fungus_protein.db /mnt/mfiles/ref/virus_protein.db"
	mega1=mega1 + "\" -m 7 -e 0.01 -W 3 -r 1 -q -3 -G 11 -E 1 -F F -a 4 -b 0 -v 5 -o /mnt/mfiles/reads/"
	mega1=mega1 + fOUT
	print mega1
       	p6=commands.getstatusoutput(mega1);
       	print p6

	#Blastxml.java
	blastxml1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
	blastxml1=blastxml1 + "blastxml.java"
	blastxml=commands.getstatusoutput(blastxml1)
	print blastxml

	# Convert BLASTXML
	blastxml1="/usr/local/jdk1.6.0_21/bin/java -classpath . blastxml /mnt/mfiles/reads/" + fOUT
	blastxml1=blastxml1 + " /mnt/mfiles/reads/"
	blastxml1=blastxml1 + fFBLASTX
	blastxml=commands.getstatusoutput(blastxml1);
       	
	# g++ blastxml.cc
        #CC1="/usr/bin/g++ blastxml.cc -o blastxml"
	#print CC1
	#p6=commands.getstatusoutput(CC1);
       	#print p6

       	# Run Blastxml.cc
        #CC1="./blastxml /mnt/mfiles/reads/" + fOUT
	#CC1=CC1 + " /mnt/mfiles/reads/"
	#CC1=CC1 + fFBLASTX
        #p6=commands.getstatusoutput(CC1);
       	#print p6
        
	# create full query from the original reads and update Hit table
        REPF1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
        REPF1=REPF1 + "extractFullQuert4BHitTable.java"
        REPF=commands.getstatusoutput(REPF1)
        FQ12FASTA="/usr/local/jdk1.6.0_21/bin/java -classpath . extractFullQuert4BHitTable /mnt/mfiles/reads/" + fFQ
        FQ12FASTA=FQ12FASTA + " /mnt/mfiles/reads/"
        FQ12FASTA=FQ12FASTA + fFBLASTX
        FQ12FASTA=FQ12FASTA + " /mnt/mfiles/reads/"
        FQ12FASTA=FQ12FASTA + fFBLASTXU
        p6=commands.getstatusoutput(FQ12FASTA);
	
	#Upload the Hittable
	out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + fFBLASTXU
        out1=out1 + " s3://"
	out1=out1 + psubo
	out1=out1 + "/"
        print out1
        p6=commands.getstatusoutput(out1);
       	print p6
	
	# Extract unmapped reads from the Hit table
        REPF1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
        REPF1=REPF1 + "extractUnmapped_latest.java"
        REPF=commands.getstatusoutput(REPF1)
        FQ12FASTA="/usr/local/jdk1.6.0_21/bin/java -classpath . extractUnmapped_latest /mnt/mfiles/reads/" + fFBLASTX
        FQ12FASTA=FQ12FASTA + " 1E-10 /mnt/mfiles/reads/"
        FQ12FASTA=FQ12FASTA + fFQ
        FQ12FASTA=FQ12FASTA + " /mnt/mfiles/reads/"
        FQ12FASTA=FQ12FASTA + fBLASTXUn
        p6=commands.getstatusoutput(FQ12FASTA);
        print p6

	#Upload the unmapped
	out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + fBLASTXUn
        out1=out1 + " s3://"
	out1=out1 + psubo
	out1=out1 + "/"
        out=commands.getstatusoutput(out1)
        print out1
	
	
	#BlastN on reads over Viral, Fungal Genome#################################### 
