
import java.io.*;


public class Sam2Fastq {

	public static void main(String args[]) throws FileNotFoundException {

		String inputFile=  args[0]; //this should be a sam file
		String outputFile= args[1]; //fastq of all unmapped reads

		long start = System.currentTimeMillis();

		long totalReadCounter 		= 0;
		long unmappedReadCounter 	= 0;
		long mappedReadCounter		= 0;

		
		try{
			BufferedWriter out = new BufferedWriter(new FileWriter(outputFile));
			FileReader fr1=new FileReader(inputFile);
			BufferedReader br=new BufferedReader(fr1);
			
			String strLine;
			while ((strLine = br.readLine()) != null)   {
				totalReadCounter++;
				if ( (totalReadCounter <= 10000000)   && (totalReadCounter % 1000000 == 0) )
					System.out.println( "Total reads: " + totalReadCounter + "\tMapped reads: " + mappedReadCounter + "\tUnmapped reads: " + unmappedReadCounter );
				if ( (totalReadCounter <= 100000000)  && (totalReadCounter % 10000000 == 0) )
					System.out.println( "Total reads: " + totalReadCounter + "\tMapped reads: " + mappedReadCounter + "\tUnmapped reads: " + unmappedReadCounter );
				if ( (totalReadCounter <= 1000000000) && (totalReadCounter % 100000000 == 0) )
					System.out.println( "Total reads: " + totalReadCounter + "\tMapped reads: " + mappedReadCounter + "\tUnmapped reads: " + unmappedReadCounter );
				if ( totalReadCounter % 1000000000 == 0 )
					System.out.println( "Total reads: " + totalReadCounter + "\tMapped reads: " + mappedReadCounter + "\tUnmapped reads: " + unmappedReadCounter );
				String[] column= strLine.split("\t");
				if ( column[2].equals("*") ) {
					unmappedReadCounter++;
					out.write(  "@" + column[0] + "\n" + 
							column[9] + "\n" +
							"+" + "\n" + 
							column[10] + "\n");
//					out.write( strLine + "\n" );
				} else
					mappedReadCounter++;
			}
			fr1.close();
			

			long elapsedTimeMillis = System.currentTimeMillis()-start;
			float elapsedTimeSec = elapsedTimeMillis/1000F;
			System.out.println(	"Process complete.\n\n" + 
					"Total reads: " + totalReadCounter + "\tMapped reads: " + mappedReadCounter + "\tUnmapped reads: " + unmappedReadCounter + "\n"
					+"CPU time: "+elapsedTimeSec);

			out.flush();
			out.close();
		}catch (Exception e){//Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}
	}
}
