
import java.util.ArrayList;
import java.util.Collections;


public class Species {

	private String genus;
	private String species;
	private int readLength;
	private int numReads;
	private int genomeSize; //in base-pairs
	private ArrayList<Integer> genomeLocs; //specific location in genome
	private double numNucCoverage;
	private double genomeCoverage;
	
	public Species(String g, String s, int gs, int rl) {
		genus= g;
		species= s;
		genomeSize= gs;
		genomeLocs= new ArrayList<Integer>();
		setReadLength(rl);
	}
	
	public void addGenomeLoc( int l ) {
		genomeLocs.add(l);
	}
	
	public double calcNumNucCoverage() {
		Collections.sort(genomeLocs);
		numNucCoverage= 0;
		for (int i=genomeLocs.size(); i>0; i--) {
			if ( i == genomeLocs.size() )
				numNucCoverage= readLength;
			else {
				if ( (genomeLocs.get(i) - genomeLocs.get(i-1)) < readLength)
					numNucCoverage= numNucCoverage + (genomeLocs.get(i) - genomeLocs.get(i-1));
				else
					numNucCoverage= numNucCoverage + readLength;
			}
		}
		
		return numNucCoverage;
	}
	
	public double calcGenomeCoverage() {
		Collections.sort(genomeLocs);
		numNucCoverage= 0;
		for (int i=genomeLocs.size(); i>0; i--) {
			if ( i == genomeLocs.size() )
				numNucCoverage= readLength;
			else {
				if ( (genomeLocs.get(i) - genomeLocs.get(i-1)) < readLength)
					numNucCoverage= numNucCoverage + (genomeLocs.get(i) - genomeLocs.get(i-1));
				else
					numNucCoverage= numNucCoverage + readLength;
			}
		}
		
		genomeCoverage= numNucCoverage/genomeSize;
		
		return genomeCoverage;
	}
	
	
	public void setNumReads(int numReads) {
		this.numReads = numReads;
	}
	public int getNumReads() {
		return numReads;
	}
	public String getGenus() {
		return genus;
	}
	public String getSpecies() {
		return species;
	}
	public int getGenomeSize() {
		return genomeSize;
	}
	public ArrayList<Integer> getGenomeLocs() {
		return genomeLocs;
	}
	public void setReadLength(int readLength) {
		this.readLength = readLength;
	}
	public int getReadLength() {
		return readLength;
	}
}
